var genNetwork = function (){
    var nodes = [];
    var that = this;
    return {
        addNode : function(node){
            console.log(node);
            if(this.isValidNode(node)){
                nodes.push(node);
                return this;
            } else {
                throw {
                    name: "invalid node",
                    message: "addNode failed because given node is invalid"
                };
            }
        },
        isValidNode : function(node){
            var props = ["name"];
            return _.chain(props)
                    .map(function(p){return node.hasOwnProperty(p);})
                    .all().value();
        },
        getNodes: function(){
            return nodes;
        }
    };
};

var nodedefs = function(){
    var defs = [];
};